import es, gamethread, os

sv = es.ServerVar
sv('hlss_version', '1.1', 'Anti HLSS by Bonbon').makepublic()

sv_options = {
	'hlss_mute_users': 0,
	'hlss_kick_users': 1,
	'hlss_ban_users': 0,
	'hlss_kick_message': 'HLSS Variable Detected, come back without HLSS!',
	'hlss_loop_time': 2.5,
	'hlss_ban_time': 5,
	'hlss_mute_time': 5,
	'hlss_warn_on_round_start': 1,
	'hlss_admins': 'STEAM_0:0:00000,STEAM_0:1:1111111',
	'hlss_immune_players': 'STEAM_0:0000000,STEAM_0:1:111111111',
}

muted_users = []

def load():
	for sv_option in sv_options:
		sv(sv_option).set(sv_options[sv_option])

	if not os.path.isfile(es.getAddonPath('hlss') + '/hlss.cfg'):
		es.dbgmsg(0, 'No config present under ./cstrike/addons/eventscripts/hlss/ !')
		return
	es.server.cmd('es_xmexec ../addons/eventscripts/hlss/hlss.cfg')
	es.server.queuecmd('mani_mute_con_command_spam 1')

	if not es.exists('saycommand', 'hlss_unmute'):
		es.regsaycmd('unmute', 'hlss/unmute_admin')

	if not es.exists('clientcommand', 'hlss_unmute'):
		es.regclientcmd('hlss_unmute', 'hlss/unmute_admin')

def unload():
	if es.exists('saycommand', 'hlss_unmute'):
		es.unregsaycmd('hlss_unmute')

	if es.exists('clientcommand', 'hlss_unmute'):
		es.unregclientcmd('hlss_unmute')

	for steamid in muted_users:
		gamethread.cancelDelayed('mute ' + steamid)

def unmute_admin():
	userid = es.getcmduserid
	if not es.getplayersteamid(userid) in str(sv('hlss_admins')).replace(' ', ''):
		es.tell(userid, '#multi', '#lightgreen[HLSS]: #defaultYou are not authorized to run this command!')
		return

	if not es.getargs():
		es.tell(userid, '#multi', '#lightgreen[HLSS]: #defaultInvalid syntax -- unmute <userid/name/steamid>')
		return

	target = es.getargs().split(' ')[0]
	if not es.getuserid(target):
		es.tell(userid, '#multi', '#lightgreen[HLSS]: #defaultNo such player #lightgreen%s'%target)
		return

	target_steam = es.getplayersteamid(es.getuserid(target))
	if not target_steam in muted_users:
		es.tell(userid, '#multi', '#lightgreen[HLSS]: #defaultPlayer is not muted!')
		return
	gamethread.cancelDelayed('mute ' + target_steamid)
	unmute(target_steamid)

def player_activate(ev):
	es.queryclientvar(ev['userid'], 'voice_inputfromfile')

def round_start(ev):
	if int(sv('hlss_warn_on_round_start')):
		es.msg('#multi', '#lightgreen[HLSS]: #defaultThis server is running #lightgreenAnti-Hlss#default, beware!')

def unload():
	gamethread.cancelDelayed('eating pie')

def eating_pie():
	gamethread.delayedname(float(sv('hlss_loop_time')), 'eating pie', eating_pie)
	for userid in es.getUseridList():
		es.queryclientvar(userid, 'voice_inputfromfile')

def player_spawn(ev):
	if ev['es_steamid'] in muted_users:
		es.server.queuecmd('ma_mute %s 1'%ev['userid'])

def es_player_variable(ev):
	if ev['status'] == 'success' and ev['variable'] == 'voice_inputfromfile' and not ev['value'] == '0':
		if not ev['es_steamid'] in str(sv('hlss_immune_players')).replace(' ', ''):
			if es.getplayersteamid(ev['userid']) in muted_users:
				return

			if int(sv('hlss_ban_users')):
				es.server.queuecmd('banid %s %s;writeid'%(ev['userid'], str(es.ServerVar('hlss_ban_time'))))

			if int(sv('hlss_kick_users')):
				es.server.queuecmd('kickid %s %s'%(ev['userid'], str(es.ServerVar('hlss_kick_message'))))
				return

			if int(sv('hlss_mute_users')):
				if not int(sv('mani_admin_plugin_version')):
					es.dbgmsg(0, 'Mani required to use mute players!')
					return

				es.server.queuecmd('ma_mute %s 1'%ev['userid'])
				muted_users.append(es.getplayersteamid(ev['userid']))
				gamethread.delayedname(float(sv('hlss_mute_time')) * 60, 'mute ' + es.getplayersteamid(ev['userid']), unmute, es.getplayersteamid(ev['userid']))
				es.tell(ev['userid'], '#multi', '#lightgreen[HLSS]: #defaultYou have been muted for #lightgreen%s#default minutes for using HLSS!'%str(sv('hlss_mute_time')))

def unmute(steamid):
	muted_users.remove(steamid)
	if es.getuserid(steamid):
		es.server.queuecmd('ma_mute %s 0'%es.getuserid(steamid))

eating_pie()